<%@ include file="/taglibs.jsp"%>

<f:view>
<f:loadBundle var="messages" basename="messages"/>

<head>
    <title><fmt:message key="userForm.title"/></title>
    <!-- JSCalendar -->
    <c:set var="ctx" value="${pageContext.request.contextPath}" scope="request"/>
    <script type="text/javascript" src="${ctx}/scripts/popcalendar.js"></script>
    <link rel="stylesheet" href="${ctx}/scripts/jscalendar-WH/theme.css" type="text/css"/>
</head>

<h:messages errorClass="error" layout="table" style="width: 100%"/>

<p>Please fill in user's information below:</p>

<h:form id="userForm" onsubmit="return validateUserForm(this)">
<h:inputHidden value="#{userForm.user.id}">
    <f:convertNumber/>
</h:inputHidden>

<table class="detail">
<tr>
    <th><h:outputLabel for="firstName" value="#{messages['user.firstName']}"/>:</th>
    <td><h:inputText value="#{userForm.user.firstName}" id="firstName"/></td>
</tr>
<tr>
    <th><h:outputLabel for="lastName" value="#{messages['user.lastName']}"/>:</th>
    <td><h:inputText value="#{userForm.user.lastName}" id="lastName" required="true">
            <v:commonsValidator type="required" arg="#{messages['user.lastName']}"/>
        </h:inputText>
        <h:message for="lastName" styleClass="errorMessage"/>
    </td>
</tr>
<tr>
    <th><h:outputLabel for="birthday" value="#{messages['user.birthday']}"/>:</th>
    <td><x:inputCalendar monthYearRowClass="yearMonthHeader" 
            weekRowClass="weekHeader" id="birthday"
            currentDayCellClass="currentDayCell" value="#{userForm.user.birthday}" 
            renderAsPopup="true"/>
        <h:message for="birthday" styleClass="errorMessage"/>
    </td>
</tr>
<tr>
    <td></td>
    <td>
        <h:commandButton value="Save" action="#{userForm.save}" id="save" styleClass="button"/>
    <c:if test="${not empty userForm.id}">
        <h:commandButton value="Delete" action="#{userForm.delete}" id="delete" styleClass="button"/>
    </c:if>
        <h:commandButton value="Cancel" action="cancel" immediate="true" id="cancel" styleClass="button"
            onclick="bCancel=true"/>
    </td>
</table>
</h:form>

<v:validatorScript functionName="validateUserForm"/>
<script type="text/javascript">
    document.forms["userForm"].elements["userForm:firstName"].focus();
</script>

<div id="calendar"></div>
</f:view>
