<%@ include file="/taglibs.jsp"%>

<f:view>
<f:loadBundle var="messages" basename="messages"/>

<title><fmt:message key="userList.title"/></title>

<h:form id="editUser">
<h:commandButton value="Add User" action="add" id="add" immediate="true" styleClass="button"/>

<%-- Step 1: Use a non-displayed dataTable to pull userList into request --%>
<h:dataTable var="user" value="#{userList.users}" style="display:none"/>

<display:table name="userList.users" class="list" requestURI="/userList.html" 
    id="userList" export="true">
    <display:column sort="true" titleKey="user.id" media="html">
        <a href="javascript:viewUser('${userList.id}')">${userList.id}</a>
    </display:column>
    <display:column property="id" media="csv excel xml pdf" titleKey="user.id"/>
    <display:column property="firstName" sort="true" titleKey="user.firstName"/>
    <display:column property="lastName" sort="true" titleKey="user.lastName"/>
    <display:column sort="true" titleKey="user.birthday" media="html">
        <!--<fmt:formatDate value="${userList.birthday}" pattern="yyyyMMdd"/>-->
        <fmt:formatDate value="${userList.birthday}" pattern="${datePattern}"/>
    </display:column>
    <display:column sort="true" titleKey="user.birthday" media="csv xml excel pdf">
        <fmt:formatDate value="${userList.birthday}" pattern="${datePattern}"/>
    </display:column>
</display:table>

<%-- JSF Hack for the Display Tag, from James Violette ~ 
         http://www.emeraldjb.com/roller/page/jviolett --%>
<%-- Step 2. Create a dummy actionLink, w/ no value --%>
<h:commandLink action="#{userForm.edit}" id="editUserLink">
    <f:param name="id"/>
</h:commandLink>
<%-- Step 3. Write your own JavaScript function that's easy to call --%>
<script type="text/javascript">
function viewUser(id) {
    var f = document.forms['editUser'];
    f.elements['editUser:_link_hidden_'].value='editUser:editUserLink';
    f.elements['id'].value=id;
    f.submit();
}
highlightTableRows("userList");
</script>

</h:form>
</f:view> 
